#include <Servo.h>
#define R PIN_PB1
#define G PIN_PB2
#define B PIN_PB0
Servo myServo;
boolean doorState = 0;   // doorState equal 0 that mean door close.
boolean carIn = 0;    // mean no car
boolean carOut = 1;   // has car
int reset = 0;

void setup() {
  pinMode(PIN_PC0, INPUT);
  pinMode(PIN_PC2, INPUT);
  pinMode(PIN_PC3, INPUT);
  pinMode(PIN_PC4, OUTPUT);
  pinMode(R,OUTPUT);      //R
  pinMode(G,OUTPUT);      //G
  pinMode(B,OUTPUT);      //B
  myServo.attach(PIN_PC1);
  while(myServo.read() > 0)
   {
        myServo.write(0);
      }
//    analogWrite(R,255);     //red
//    analogWrite(G,255);
//    analogWrite(B,0); 
//    delay(1000);
//      analogWrite(R,0);     //green
//      analogWrite(G,255);
//      analogWrite(B,255); 
//      delay(1000);
      analogWrite(R,255);     //blue
      analogWrite(G,0);
      analogWrite(B,255); 
      delay(1000);
  pinMode(PIN_PD3, OUTPUT);
}

void loop() {
  int touch = 0,
      touch2 = 0,
      touch3 = 0;
  touch = digitalRead(PIN_PC0);
  touch2 = digitalRead(PIN_PC2);
  touch3 = digitalRead(PIN_PC3);
  
  if(touch)
  {
    if(!doorState && !carIn ) // && carIn   open-door  outdoor
    {
      int count = 0;
      while(count < 3) {
        tone(PIN_PC4, 4000); // Send 1KHz sound signal...
        delay(500);        // ...for 1 sec
        noTone(PIN_PC4);     // Stop sound...
        delay(100);
        count++;
      }
      while(myServo.read() < 180)
      {
        analogWrite(R,0);     //green
        analogWrite(G,255);
        analogWrite(B,255); 
        myServo.write(180);
      }
      delay(3000);
      analogWrite(R,255);     //blue
      analogWrite(G,0);
      analogWrite(B,255); 
      doorState = !doorState;
      carIn = !carIn;     // has car
    }    
    else if(doorState && carIn ) // && !carOut   close-door  outdoor
    {
      int count = 0;
      while(count < 3) {
        tone(PIN_PC4, 500); // Send 1KHz sound signal...
        delay(500);        // ...for 1 sec
        noTone(PIN_PC4);     // Stop sound...
        delay(100);
        count++;
      }
      while(myServo.read() > 0)
      {
        analogWrite(R,255);     //red
        analogWrite(G,255);
        analogWrite(B,0); 
        myServo.write(0);
      }
      delay(3000);
      analogWrite(R,255);     //blue
      analogWrite(G,0);
      analogWrite(B,255); 
      doorState = !doorState;  //door close
      //carOut = !carOut;   // carOut =  0  mean no car
      carIn = 0;     //reset
      reset = 0;
    }    
  }

  if(touch2)
  {
    if(doorState && carIn)  // && carIn  close-door  indoor
    {
      int count = 0;
      while(count < 3) {
        tone(PIN_PC4, 500); // Send 1KHz sound signal...
        delay(500);        // ...for 1 sec
        noTone(PIN_PC4);     // Stop sound...
        delay(100);
        count++;
      }
       while(myServo.read() > 0)
      {
        analogWrite(R,255);     //red
        analogWrite(G,255);
        analogWrite(B,0); 
        myServo.write(0);
      }
      delay(3000);
      analogWrite(R,255);     //blue
      analogWrite(G,0);
      analogWrite(B,255); 
      doorState = !doorState;   // door close
      //carIn = !carIn;
      //reset = 1;
    }
  }

  if(touch3)
  {
    if(!doorState && carIn)  
    {
      int count = 0;
      while(count < 3) {
        tone(PIN_PC4, 4000); // Send 1KHz sound signal...
        delay(500);        // ...for 1 sec
        noTone(PIN_PC4);     // Stop sound...
        delay(100);
        count++;
      }
       while(myServo.read() < 180)    // car out  open-door indoor
      {
        analogWrite(R,0);     //green
        analogWrite(G,255);
        analogWrite(B,255); 
        myServo.write(180);
      }
      delay(3000);
      analogWrite(R,255);     //blue
      analogWrite(G,0);
      analogWrite(B,255); 
      doorState = !doorState;   // doorState = 1
      //carOut = !carOut;       // carOut =  0  mean na car
    }
  }
}
